/**************************************************************************

	ns

	view.h

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

#ifndef VIEW_H
#define VIEW_H

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>


/**************************************************************************
	Define
**************************************************************************/

#define VIEW_WND_CLASS			TEXT("nsView")

//̒ǉ
#define WM_ADDTEXT				(WM_APP + 100)
//struct _BUFFER ̎擾
#define WM_GETBUFFERINFO		(WM_APP + 101)
//tHgsԕύX̔f
#define WM_REFLECT				(WM_APP + 105)

#define WM_GETCHAR				(WM_APP + 1000)
#define WM_GETS					(WM_APP + 1001)
#define WM_SETECHO				(WM_APP + 1002)
#define WM_INITVIEW				(WM_APP + 1003)

#define TH_GETS					(WM_APP + 1100)
#define TH_GETCHAR				(WM_APP + 1200)

#define INPUT_SIZE				256


/**************************************************************************
	Struct
**************************************************************************/

typedef struct _BUFFER {
	//ێĂe
	TCHAR *buf;
	//buf ̊mۂĂTCY
	int size;
	//buf '\0'܂ł̒
	int len;

	TCHAR *InputBuf;

	//\s̃ItZbg (buf + line[3] 4sڂ̈ʒu)
	int *line;
	//\s̒
	int *linelen;
	//line ̊mۂĂTCY
	int linesize;
	//line ̍ŏIs̈ʒu
	int maxline;
	//EBhE̕
	int width;

	//XN[ o[̂܂݂݂̌̈ʒu
	int pos;
	//XN[ o[݂̌̂܂݂̈ʒu̍ől
	int max;

	//I𕶎ʒu
	TCHAR *sp;
	TCHAR *ep;
	//Lbg̉ʒu
	int cx;

	//ő啶
	int Limit;
	//^uXgbv
	int TabStop;
	//}[W
	int LeftMargin;
	//E}[W
	int RightMargin;
	//s
	int Spacing;

	//`p
	HDC mdc;
	HBITMAP hBmp;
	HBITMAP hRetBmp;
	//wiF̃uV
	HBRUSH hBkBrush;

	//tHg̍
	int FontHeight;
	//1̃tHg̕
	int CharWidth;

	//}EXtO
	BOOL mousedown;

	BOOL echo;
	BOOL lineFlag;
	TCHAR *lineBuf;
	int tid;
} BUFFER;


/**************************************************************************
	Function Prototypes
**************************************************************************/

COLORREF GetColor(char c, COLORREF def);
TCHAR *SetColor(TCHAR *p, char *ret, char *style);
LRESULT CALLBACK ViewProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL RegistViewWindow(HINSTANCE hInstance);

#endif
/* End of source */
